diff --git a/src/widgets/kernel/qtooltip.cpp b/src/widgets/kernel/qtooltip.cpp
index 69b62ff7d7..1cdf1f45ea 100644
--- a/src/widgets/kernel/qtooltip.cpp
+++ b/src/widgets/kernel/qtooltip.cpp
@@ -178,6 +178,7 @@ QTipLabel::QTipLabel(const QString &text, QWidget *w, int msecDisplayTime)
 {
     delete instance;
     instance = this;
+    qDebug() << __FUNCTION__;
     setForegroundRole(QPalette::ToolTipText);
     setBackgroundRole(QPalette::ToolTipBase);
     setPalette(QToolTip::palette());
@@ -191,6 +192,7 @@ QTipLabel::QTipLabel(const QString &text, QWidget *w, int msecDisplayTime)
     setMouseTracking(true);
     fadingOut = false;
     reuseTip(text, msecDisplayTime);
+    qDebug() << __FUNCTION__ << '<';
 }
 
 void QTipLabel::restartExpireTimer(int msecDisplayTime)
@@ -209,6 +211,7 @@ void QTipLabel::reuseTip(const QString &text, int msecDisplayTime)
         disconnect(styleSheetParent, SIGNAL(destroyed()),
                    QTipLabel::instance, SLOT(styleSheetParentDestroyed()));
         styleSheetParent = 0;
+        qDebug() << __FUNCTION__ << "styleSheetParent = 0";
     }
 #endif
 
@@ -276,6 +279,7 @@ void QTipLabel::hideTipImmediately()
 
 void QTipLabel::setTipRect(QWidget *w, const QRect &r)
 {
+    qDebug() << __FUNCTION__ << r;
     if (Q_UNLIKELY(!r.isNull() && !w)) {
         qWarning("QToolTip::setTipRect: Cannot pass null widget if rect is set");
         return;
@@ -376,6 +380,7 @@ int QTipLabel::getTipScreen(const QPoint &pos, QWidget *w)
 void QTipLabel::placeTip(const QPoint &pos, QWidget *w)
 {
 #ifndef QT_NO_STYLE_STYLESHEET
+    qDebug() << __FUNCTION__ << "WA_StyleSheet=" << testAttribute(Qt::WA_StyleSheet);
     if (testAttribute(Qt::WA_StyleSheet) || (w && qobject_cast<QStyleSheetStyle *>(w->style()))) {
         //the stylesheet need to know the real parent
         QTipLabel::instance->setProperty("_q_stylesheet_parent", QVariant::fromValue(w));
@@ -384,6 +389,7 @@ void QTipLabel::placeTip(const QPoint &pos, QWidget *w)
 
         // Set up for cleaning up this later...
         QTipLabel::instance->styleSheetParent = w;
+        qDebug() << __FUNCTION__ << "set QTipLabel::instance->styleSheetParent" << w;
         if (w) {
             connect(w, SIGNAL(destroyed()),
                 QTipLabel::instance, SLOT(styleSheetParentDestroyed()));
diff --git a/src/widgets/kernel/qwidget.cpp b/src/widgets/kernel/qwidget.cpp
index 74f2dc0c41..50f60e1cf1 100644
--- a/src/widgets/kernel/qwidget.cpp
+++ b/src/widgets/kernel/qwidget.cpp
@@ -1204,6 +1204,7 @@ void QWidgetPrivate::init(QWidget *parentWidget, Qt::WindowFlags f)
         const QBrush &background = q->palette().brush(QPalette::Window);
         setOpaque(q->isWindow() && background.style() != Qt::NoBrush && background.isOpaque());
     }
+    qDebug() << __FUNCTION__ << q << "data.fnt=" << data.fnt;
     data.fnt = QFont(data.fnt, q);
 #if 0 // Used to be included in Qt4 for Q_WS_X11
     data.fnt.x11SetScreen(xinfo.screen());
@@ -4685,6 +4686,7 @@ void QWidgetPrivate::updateSystemBackground()
 void QWidget::setFont(const QFont &font)
 {
     Q_D(QWidget);
+    qDebug() << __FUNCTION__ << this << font;
 
 #ifndef QT_NO_STYLE_STYLESHEET
     const QStyleSheetStyle* style;
@@ -4719,6 +4721,7 @@ void QWidget::setFont(const QFont &font)
 QFont QWidgetPrivate::naturalWidgetFont(uint inheritedMask) const
 {
     Q_Q(const QWidget);
+    qDebug() << __FUNCTION__ << q << inheritedMask;
 
     const bool useStyleSheetPropagationInWidgetStyles =
         QCoreApplication::testAttribute(Qt::AA_UseStyleSheetPropagationInWidgetStyles);
@@ -4730,15 +4733,19 @@ QFont QWidgetPrivate::naturalWidgetFont(uint inheritedMask) const
             || (extra && extra->proxyWidget)
 #endif // QT_CONFIG(graphicsview)
             )) {
+        qDebug() << __FUNCTION__ << "C1";
         if (QWidget *p = q->parentWidget()) {
+            qDebug() << __FUNCTION__ << "par=" << p;
             if (!p->testAttribute(Qt::WA_StyleSheet) || useStyleSheetPropagationInWidgetStyles) {
                 if (!naturalFont.isCopyOf(QApplication::font())) {
+                    qDebug() << __FUNCTION__ << "!naturalFont.isCopyOf" ;
                     if (inheritedMask != 0) {
                         QFont inheritedFont = p->font();
                         inheritedFont.resolve(inheritedMask);
                         naturalFont = inheritedFont.resolve(naturalFont);
                     } // else nothing to do (naturalFont = naturalFont)
                 } else {
+                    qDebug() << __FUNCTION__ << "naturalFont.isCopyOf->p" ;
                     naturalFont = p->font();
                 }
             }
@@ -4754,6 +4761,7 @@ QFont QWidgetPrivate::naturalWidgetFont(uint inheritedMask) const
 #endif // QT_CONFIG(graphicsview)
     }
     naturalFont.resolve(0);
+     qDebug() << __FUNCTION__ << "<" <<naturalFont ;
     return naturalFont;
 }
 
@@ -4767,8 +4775,12 @@ QFont QWidgetPrivate::naturalWidgetFont(uint inheritedMask) const
 */
 void QWidgetPrivate::resolveFont()
 {
+    qDebug() << __FUNCTION__ << q_func();
     QFont naturalFont = naturalWidgetFont(inheritedFontResolveMask);
     QFont resolvedFont = data.fnt.resolve(naturalFont);
+    qDebug() << __FUNCTION__ << q_func()
+             << "nat=" << naturalFont
+             << "\nres=" << resolvedFont;
     setFont_helper(resolvedFont);
 }
 
@@ -4791,6 +4803,7 @@ void QWidgetPrivate::updateFont(const QFont &font)
         QCoreApplication::testAttribute(Qt::AA_UseStyleSheetPropagationInWidgetStyles);
 #endif
 
+    qDebug() << __FUNCTION__ << q << "data.fnt=" << font;
     data.fnt = QFont(font, q);
 #if 0 // Used to be included in Qt4 for Q_WS_X11
     // make sure the font set on this widget is associated with the correct screen
@@ -4820,6 +4833,7 @@ void QWidgetPrivate::updateFont(const QFont &font)
 #endif
             } else if ((!w->isWindow() || w->testAttribute(Qt::WA_WindowPropagation))) {
                 // Propagate font changes.
+                qDebug() << __FUNCTION__ << "prop child" << w;
                 QWidgetPrivate *wd = w->d_func();
                 wd->inheritedFontResolveMask = newMask;
                 wd->resolveFont();
@@ -8997,6 +9011,10 @@ bool QWidget::event(QEvent *event)
     case QEvent::Polish: {
         style()->polish(this);
         setAttribute(Qt::WA_WState_Polished);
+        QFont tf  = QApplication::font(this);
+        qDebug() << __FUNCTION__ << this
+                 << "sCopyOf(QApplication::font()"
+                 << tf << tf.isCopyOf(QApplication::font());
         if (!QApplication::font(this).isCopyOf(QApplication::font()))
             d->resolveFont();
         if (!QApplication::palette(this).isCopyOf(QApplication::palette()))
diff --git a/src/widgets/styles/qstylesheetstyle.cpp b/src/widgets/styles/qstylesheetstyle.cpp
index e12aeb900b..d5c0c1f55a 100644
--- a/src/widgets/styles/qstylesheetstyle.cpp
+++ b/src/widgets/styles/qstylesheetstyle.cpp
@@ -1451,8 +1451,10 @@ static inline QObject *parentObject(const QObject *obj)
 #if QT_CONFIG(tooltip)
     if (qobject_cast<const QLabel *>(obj) && qstrcmp(obj->metaObject()->className(), "QTipLabel") == 0) {
         QObject *p = qvariant_cast<QObject *>(obj->property("_q_stylesheet_parent"));
-        if (p)
+        if (p) {
+            qDebug() << __FUNCTION__ << obj  << "->" << p;
             return p;
+        }
     }
 #endif
     return obj->parent();
diff --git a/src/widgets/widgets/qlabel.cpp b/src/widgets/widgets/qlabel.cpp
index ee4825d3e5..b38ca04721 100644
--- a/src/widgets/widgets/qlabel.cpp
+++ b/src/widgets/widgets/qlabel.cpp
@@ -555,6 +555,7 @@ void QLabel::setMargin(int margin)
 QSize QLabelPrivate::sizeForWidth(int w) const
 {
     Q_Q(const QLabel);
+    qDebug() << __FUNCTION__ << q << w << q->font();
     if(q->minimumWidth() > 0)
         w = qMax(w, q->minimumWidth());
     QSize contentsMargin(leftmargin + rightmargin, topmargin + bottommargin);
@@ -640,7 +641,9 @@ QSize QLabelPrivate::sizeForWidth(int w) const
     }
 
     const QSize contentsSize(br.width() + hextra, br.height() + vextra);
-    return (contentsSize + contentsMargin).expandedTo(q->minimumSize());
+    QSize r = (contentsSize + contentsMargin).expandedTo(q->minimumSize());
+    qDebug() << __FUNCTION__ << q << "rets" << r;
+    return r;
 }
 
 
@@ -823,6 +826,7 @@ QSize QLabel::sizeHint() const
     Q_D(const QLabel);
     if (!d->valid_hints)
         (void) QLabel::minimumSizeHint();
+    qDebug() << __FUNCTION__ << this << "rets" << d->sh;
     return d->sh;
 }
 
@@ -852,6 +856,7 @@ QSize QLabel::minimumSizeHint() const
     }
     d->msh = msh;
     d->sizePolicy = sizePolicy();
+    qDebug() << __FUNCTION__ << this << "rets" << msh;
     return msh;
 }
 