diff --git a/src/quick/items/qquickitem.cpp b/src/quick/items/qquickitem.cpp
index 3a0aea517..f728c21ed 100644
--- a/src/quick/items/qquickitem.cpp
+++ b/src/quick/items/qquickitem.cpp
@@ -3896,6 +3896,7 @@ void QQuickItem::updatePolish()
 
 void QQuickItemPrivate::addItemChangeListener(QQuickItemChangeListener *listener, ChangeTypes types)
 {
+    qDebug() << __FUNCTION__ << listener << types;
     changeListeners.append(ChangeListener(listener, types));
 }
 
@@ -6233,6 +6234,7 @@ void QQuickItemPrivate::itemChange(QQuickItem::ItemChange change, const QQuickIt
     case QQuickItem::ItemAntialiasingHasChanged:
         // fall through
     case QQuickItem::ItemDevicePixelRatioHasChanged:
+        qDebug() << __FUNCTION__ << change;
         q->itemChange(change, data);
         break;
     }
diff --git a/src/quick/items/qquickwindow.cpp b/src/quick/items/qquickwindow.cpp
index 48eba6a7a..15f19b033 100644
--- a/src/quick/items/qquickwindow.cpp
+++ b/src/quick/items/qquickwindow.cpp
@@ -339,6 +339,7 @@ void QQuickWindow::update()
 
 static void updatePixelRatioHelper(QQuickItem *item, float pixelRatio)
 {
+    qDebug() << __FUNCTION__ << item << "dpr=" << pixelRatio;
     if (item->flags() & QQuickItem::ItemHasContents) {
         QQuickItemPrivate *itemPrivate = QQuickItemPrivate::get(item);
         itemPrivate->itemChange(QQuickItem::ItemDevicePixelRatioHasChanged, pixelRatio);
@@ -353,6 +354,7 @@ void QQuickWindow::physicalDpiChanged()
 {
     Q_D(QQuickWindow);
     const qreal newPixelRatio = screen()->devicePixelRatio();
+    qDebug() << __FUNCTION__ << this << "newPixelRatio" << newPixelRatio;
     if (qFuzzyCompare(newPixelRatio, d->devicePixelRatio))
         return;
     d->devicePixelRatio = newPixelRatio;
@@ -363,6 +365,7 @@ void QQuickWindow::physicalDpiChanged()
 void QQuickWindow::handleScreenChanged(QScreen *screen)
 {
     Q_D(QQuickWindow);
+    qDebug() << __FUNCTION__ << this << screen->name();
     if (screen) {
         physicalDpiChanged();
         // When physical DPI changes on the same screen, either the resolution or the device pixel
diff --git a/src/quickwidgets/qquickwidget.cpp b/src/quickwidgets/qquickwidget.cpp
index 920b400ea..6129903fa 100644
--- a/src/quickwidgets/qquickwidget.cpp
+++ b/src/quickwidgets/qquickwidget.cpp
@@ -96,6 +96,7 @@ void QQuickWidgetPrivate::init(QQmlEngine* e)
     renderControl = new QQuickWidgetRenderControl(q);
     offscreenWindow = new QQuickWindow(renderControl);
     offscreenWindow->setTitle(QString::fromLatin1("Offscreen"));
+    offscreenWindow->setObjectName("Offscreen");
     // Do not call create() on offscreenWindow.
 
     // Check if the Software Adaptation is being used
@@ -254,6 +255,7 @@ void QQuickWidgetPrivate::execute()
 void QQuickWidgetPrivate::itemGeometryChanged(QQuickItem *resizeItem, QQuickGeometryChange change,
                                               const QRectF &oldGeometry)
 {
+    qDebug() << __FUNCTION__ << resizeItem << oldGeometry;
     Q_Q(QQuickWidget);
     if (resizeItem == root && resizeMode == QQuickWidget::SizeViewToRootObject) {
         // wait for both width and height to be changed
@@ -743,6 +745,7 @@ QList<QQmlError> QQuickWidget::errors() const
 void QQuickWidget::setResizeMode(ResizeMode mode)
 {
     Q_D(QQuickWidget);
+    qDebug() << __FUNCTION__ << mode;
     if (d->resizeMode == mode)
         return;
 
@@ -761,6 +764,7 @@ void QQuickWidget::setResizeMode(ResizeMode mode)
 
 void QQuickWidgetPrivate::initResize()
 {
+    qDebug() << __FUNCTION__;
     if (root) {
         if (resizeMode == QQuickWidget::SizeViewToRootObject) {
             QQuickItemPrivate *p = QQuickItemPrivate::get(root);
@@ -772,12 +776,14 @@ void QQuickWidgetPrivate::initResize()
 
 void QQuickWidgetPrivate::updateSize()
 {
+    qDebug() <<       __FUNCTION__ ;
     Q_Q(QQuickWidget);
     if (!root)
         return;
 
     if (resizeMode == QQuickWidget::SizeViewToRootObject) {
         QSize newSize = QSize(root->width(), root->height());
+qDebug() <<       __FUNCTION__ <<   newSize << "dpr"<< q->devicePixelRatioF();
         if (newSize.isValid() && newSize != q->size()) {
             q->resize(newSize);
             q->updateGeometry();
@@ -1120,6 +1126,7 @@ void QQuickWidget::timerEvent(QTimerEvent* e)
     Q_D(QQuickWidget);
     if (!e || e->timerId() == d->resizetimer.timerId()) {
         d->updateSize();
+        qDebug() << __FUNCTION__ << "resizetimer";
         d->resizetimer.stop();
     } else if (e->timerId() == d->updateTimer.timerId()) {
         d->eventPending = false;
diff --git a/tests/auto/qml/ecmascripttests/test262 b/tests/auto/qml/ecmascripttests/test262
index e505c11ee..fe58b18c1 160000
--- a/tests/auto/qml/ecmascripttests/test262
+++ b/tests/auto/qml/ecmascripttests/test262
@@ -1 +1 @@
-Subproject commit e505c11eebe5a389a7d47a4bf570c66469740b01
+Subproject commit fe58b18c13d1ea5d42951e5b698efc3bfab6dc8c