diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index caa8aaca4b..603c4d1c4a 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -2318,6 +2318,7 @@ void QGuiApplicationPrivate::processWindowStateChangedEvent(QWindowSystemInterfa
 
 void QGuiApplicationPrivate::processWindowScreenChangedEvent(QWindowSystemInterfacePrivate::WindowScreenChangedEvent *wse)
 {
+    qDebug() << __FUNCTION__ << "event=" << wse << wse->window <<wse->screen.data()->name();
     if (QWindow *window  = wse->window.data()) {
         if (window->screen() == wse->screen.data())
             return;
diff --git a/src/gui/kernel/qplatformwindow.cpp b/src/gui/kernel/qplatformwindow.cpp
index a66420c364..6b824bf6b6 100644
--- a/src/gui/kernel/qplatformwindow.cpp
+++ b/src/gui/kernel/qplatformwindow.cpp
@@ -701,6 +701,8 @@ QRect QPlatformWindow::initialGeometry(const QWindow *w,
             }
         }
     }
+    qDebug() << __FUNCTION__ << w << rect<<  screen
+             << "QCursor::pos=" << QCursor::pos();
     return QHighDpi::toNativePixels(rect, screen);
 }
 
diff --git a/src/gui/kernel/qwindow.cpp b/src/gui/kernel/qwindow.cpp
index 2c7e061bcf..1dc192e4f4 100644
--- a/src/gui/kernel/qwindow.cpp
+++ b/src/gui/kernel/qwindow.cpp
@@ -1820,6 +1820,9 @@ void QWindow::resize(const QSize &newSize)
     Q_D(QWindow);
     d->positionPolicy = QWindowPrivate::WindowFrameExclusive;
     if (d->platformWindow) {
+        qDebug() << __FUNCTION__  << newSize
+                 << screen()->name()
+                 << "toNativePixels=:" << QHighDpi::toNativePixels(QRect(position(), newSize), this);
         d->platformWindow->setGeometry(QHighDpi::toNativePixels(QRect(position(), newSize), this));
     } else {
         const QSize oldSize = d->geometry.size();
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 5243ae66a2..a4a32d75ff 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -260,8 +260,11 @@ QT_DEFINE_QPA_EVENT_HANDLER(void, handleWindowStateChanged, QWindow *window, Qt:
 
 void QWindowSystemInterface::handleWindowScreenChanged(QWindow *window, QScreen *screen)
 {
+
     QWindowSystemInterfacePrivate::WindowScreenChangedEvent *e =
         new QWindowSystemInterfacePrivate::WindowScreenChangedEvent(window, screen);
+    qDebug() << __FUNCTION__ << window << screen->name()
+             << "event=" << e;
     QWindowSystemInterfacePrivate::handleWindowSystemEvent(e);
 }
 
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index f1762146ec..ac9d442397 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -651,7 +651,7 @@ QWindowsWindowData
     const QWindowCreationContextPtr context(new QWindowCreationContext(w, data.geometry, rect, data.customMargins, style, exStyle));
     QWindowsContext::instance()->setWindowCreationContext(context);
 
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << "CreateWindowEx: " << w << " class=" << windowClassName << " title=" << title
         << '\n' << *this << "\nrequested: " << rect << ": "
         << context->frameWidth << 'x' <<  context->frameHeight
@@ -663,7 +663,7 @@ QWindowsWindowData
                                  context->frameX, context->frameY,
                                  context->frameWidth, context->frameHeight,
                                  parentHandle, NULL, appinst, NULL);
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << "CreateWindowEx: returns " << w << ' ' << result.hwnd << " obtained geometry: "
         << context->obtainedGeometry << ' ' << context->margins;
 
@@ -1131,6 +1131,7 @@ QWindowsWindow::~QWindowsWindow()
 
 void QWindowsWindow::initialize()
 {
+    qDebug() << __FUNCTION__ << '>';
     // Clear the creation context as the window can be found in QWindowsContext's map.
     QWindowCreationContextPtr creationContext =
         QWindowsContext::instance()->setWindowCreationContext(QWindowCreationContextPtr());
@@ -1150,6 +1151,7 @@ void QWindowsWindow::initialize()
         if (obtainedScreen && screen() != obtainedScreen)
             QWindowSystemInterface::handleWindowScreenChanged(w, obtainedScreen->screen());
     }
+    qDebug() << __FUNCTION__ << "<leaving";
 }
 
 void QWindowsWindow::fireExpose(const QRegion &region, bool force)
@@ -1688,10 +1690,12 @@ void QWindowsBaseWindow::setGeometry_sys(const QRect &rect) const
     const QMargins margins = frameMargins();
     const QRect frameGeometry = rect + margins;
 
-    qCDebug(lcQpaWindows) << '>' << __FUNCTION__ << window()
+    qDebug() << '>' << __FUNCTION__ << window()
         << "\n from " << geometry_sys() << " frame: "
         << margins << " to " <<rect
         << " new frame: " << frameGeometry;
+    if (rect.width() == 800)
+        qDebug("800");
 
     bool result = false;
     const HWND hwnd = handle();
diff --git a/src/widgets/kernel/qwidget.cpp b/src/widgets/kernel/qwidget.cpp
index a86834002c..1758e956d9 100644
--- a/src/widgets/kernel/qwidget.cpp
+++ b/src/widgets/kernel/qwidget.cpp
@@ -7228,6 +7228,7 @@ void QWidget::setGeometry(const QRect &r)
 void QWidgetPrivate::setGeometry_sys(int x, int y, int w, int h, bool isMove)
 {
     Q_Q(QWidget);
+    qDebug() << __FUNCTION__ << q;
     if (extra) {                                // any size restrictions?
         w = qMin(w,extra->maxw);
         h = qMin(h,extra->maxh);
@@ -7286,6 +7287,7 @@ void QWidgetPrivate::setGeometry_sys(int x, int y, int w, int h, bool isMove)
     if (q->isVisible()) {
         if (!q->testAttribute(Qt::WA_DontShowOnScreen) && !q->testAttribute(Qt::WA_OutsideWSRange)) {
             if (QWindow *win = q->windowHandle()) {
+                qDebug() << __FUNCTION__ << "Adapting isResize=" << isResize << "isMove=" << isMove;
                 if (q->isWindow()) {
                     if (isResize && !isMove)
                         win->resize(w, h);
@@ -8064,6 +8066,7 @@ void QWidgetPrivate::show_helper()
 void QWidgetPrivate::show_sys()
 {
     Q_Q(QWidget);
+    qDebug() << __FUNCTION__ << q;
 
     QWidgetWindow *window = windowHandle();
 
@@ -8102,11 +8105,13 @@ void QWidgetPrivate::show_sys()
         const QRect windowRect = window->geometry();
         if (windowRect != geomRect) {
             if (q->testAttribute(Qt::WA_Moved)
-                || !QGuiApplicationPrivate::platformIntegration()->hasCapability(QPlatformIntegration::WindowManagement))
+                || !QGuiApplicationPrivate::platformIntegration()->hasCapability(QPlatformIntegration::WindowManagement)) {
                 window->setGeometry(geomRect);
-            else
+        } else {
+                qDebug() << __FUNCTION__ << "resizing";
                 window->resize(geomRect.size());
         }
+        }
 
 #ifndef QT_NO_CURSOR
         qt_qpa_set_cursor(q, false); // Needed in case cursor was set before show