diff --git a/src/widgets/kernel/qtooltip.cpp b/src/widgets/kernel/qtooltip.cpp
index ed7184302a..65e8d7c81b 100644
--- a/src/widgets/kernel/qtooltip.cpp
+++ b/src/widgets/kernel/qtooltip.cpp
@@ -46,6 +46,7 @@
 #include <qdesktopwidget.h>
 #include <private/qdesktopwidget_p.h>
 #include <qevent.h>
+#include <qdebug.h>
 #include <qpointer.h>
 #include <qstyle.h>
 #include <qstyleoption.h>
@@ -201,11 +202,14 @@ void QTipLabel::restartExpireTimer(int msecDisplayTime)
     if (msecDisplayTime > 0)
         time = msecDisplayTime;
     expireTimer.start(time, this);
+    qDebug() << __FUNCTION__ << time;
     hideTimer.stop();
 }
 
 void QTipLabel::reuseTip(const QString &text, int msecDisplayTime)
 {
+    qDebug() << __FUNCTION__ << text << msecDisplayTime
+             << sizeHint() << "styleSheetParent=" << styleSheetParent;
 #ifndef QT_NO_STYLE_STYLESHEET
     if (styleSheetParent){
         disconnect(styleSheetParent, SIGNAL(destroyed()),
@@ -216,18 +220,24 @@ void QTipLabel::reuseTip(const QString &text, int msecDisplayTime)
 
     setWordWrap(Qt::mightBeRichText(text));
     setText(text);
+    QFont f = font();
+    QFontMetrics fm(f);
+    qDebug() << __FUNCTION__ << f.family() << f.pointSize() << "pt" << f.pixelSize() << "px";
     updateSize();
     restartExpireTimer(msecDisplayTime);
 }
 
 void  QTipLabel::updateSize()
 {
-    QFontMetrics fm(font());
+    QFont f = font();
+    QFontMetrics fm(f);
     QSize extra(1, 0);
     // Make it look good with the default ToolTip font on Mac, which has a small descent.
     if (fm.descent() == 2 && fm.ascent() >= 11)
         ++extra.rheight();
-    resize(sizeHint() + extra);
+    QSize s = sizeHint() + extra;
+    qDebug() << __FUNCTION__ << s << sender() << f.family() << f.pointSizeF();
+    resize(s);
 }
 
 void QTipLabel::paintEvent(QPaintEvent *ev)
@@ -248,6 +258,7 @@ void QTipLabel::resizeEvent(QResizeEvent *e)
     option.init(this);
     if (style()->styleHint(QStyle::SH_ToolTip_Mask, &option, this, &frameMask))
         setMask(frameMask.region);
+    qDebug() << __FUNCTION__ << e << "frameMask=" << frameMask.region;
 
     QLabel::resizeEvent(e);
 }
@@ -283,6 +294,7 @@ void QTipLabel::hideTipImmediately()
 
 void QTipLabel::setTipRect(QWidget *w, const QRect &r)
 {
+    qDebug() << __FUNCTION__ << w << r;
     if (Q_UNLIKELY(!r.isNull() && !w)) {
         qWarning("QToolTip::setTipRect: Cannot pass null widget if rect is set");
         return;
@@ -380,6 +392,7 @@ int QTipLabel::getTipScreen(const QPoint &pos, QWidget *w)
 
 void QTipLabel::placeTip(const QPoint &pos, QWidget *w)
 {
+    qDebug() << __FUNCTION__ << pos  << w;
 #ifndef QT_NO_STYLE_STYLESHEET
     if (testAttribute(Qt::WA_StyleSheet) || (w && qobject_cast<QStyleSheetStyle *>(w->style()))) {
         //the stylesheet need to know the real parent
@@ -394,6 +407,7 @@ void QTipLabel::placeTip(const QPoint &pos, QWidget *w)
                 QTipLabel::instance, SLOT(styleSheetParentDestroyed()));
             // QTBUG-64550: A font inherited by the style sheet might change the size,
             // particular on Windows, where the tip is not parented on a window.
+            qDebug() << __FUNCTION__ << "Calling updateSize ";
             QTipLabel::instance->updateSize();
         }
     }
@@ -485,6 +499,7 @@ void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w, cons
 
 void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w, const QRect &rect, int msecDisplayTime)
 {
+    qDebug() << __FUNCTION__ << pos << text << w << rect;
     if (QTipLabel::instance && QTipLabel::instance->isVisible()){ // a tip does already exist
         if (text.isEmpty()){ // empty text means hide current tip
             QTipLabel::instance->hideTip();
diff --git a/src/widgets/kernel/qwidget.cpp b/src/widgets/kernel/qwidget.cpp
index a86834002c..9ca6eded6a 100644
--- a/src/widgets/kernel/qwidget.cpp
+++ b/src/widgets/kernel/qwidget.cpp
@@ -7192,6 +7192,8 @@ void QWidgetPrivate::fixPosIncludesFrame()
 
 void QWidget::resize(const QSize &s)
 {
+    if (inherits("QTipLabel"))
+        qDebug() << __FUNCTION__ << this << s;
     Q_D(QWidget);
     setAttribute(Qt::WA_Resized);
     if (testAttribute(Qt::WA_WState_Created)) {
diff --git a/src/widgets/widgets/qlabel.cpp b/src/widgets/widgets/qlabel.cpp
index 947da273dd..e16ba8db32 100644
--- a/src/widgets/widgets/qlabel.cpp
+++ b/src/widgets/widgets/qlabel.cpp
@@ -833,8 +833,11 @@ QSize QLabel::minimumSizeHint() const
 {
     Q_D(const QLabel);
     if (d->valid_hints) {
-        if (d->sizePolicy == sizePolicy())
+        if (d->sizePolicy == sizePolicy()) {
+            qDebug() << __FUNCTION__ << '1' << d->msh
+                     << "Qt::WA_StyleSheet=" << testAttribute(Qt::WA_StyleSheet);
             return d->msh;
+        }
     }
 
     ensurePolished();
@@ -852,6 +855,8 @@ QSize QLabel::minimumSizeHint() const
     }
     d->msh = msh;
     d->sizePolicy = sizePolicy();
+    qDebug() << __FUNCTION__ << '2' << d->msh
+                  << "Qt::WA_StyleSheet=" << testAttribute(Qt::WA_StyleSheet);
     return msh;
 }
 