diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index 2ef689b5b9..225ec6ac0e 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -2258,6 +2258,7 @@ void QGuiApplicationPrivate::processActivatedEvent(QWindowSystemInterfacePrivate
 {
     QWindow *previous = QGuiApplicationPrivate::focus_window;
     QWindow *newFocus = e->activated.data();
+    qDebug() << __FUNCTION__ << newFocus;
 
     if (previous == newFocus)
         return;
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index 6edcdfc255..4c0e38e1e6 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -432,6 +432,7 @@ void QWindowSystemInterface::handleFrameStrutMouseEvent(QWindow *window, ulong t
 bool QWindowSystemInterface::handleShortcutEvent(QWindow *window, ulong timestamp, int keyCode, Qt::KeyboardModifiers modifiers, quint32 nativeScanCode,
                                       quint32 nativeVirtualKey, quint32 nativeModifiers, const QString &text, bool autorepeat, ushort count)
 {
+    qDebug() << __FUNCTION__;
 #ifndef QT_NO_SHORTCUT
     if (!window)
         window = QGuiApplication::focusWindow();
diff --git a/src/plugins/platforms/windows/qtwindowsglobal.h b/src/plugins/platforms/windows/qtwindowsglobal.h
index 6c44541314..618daeeb0c 100644
--- a/src/plugins/platforms/windows/qtwindowsglobal.h
+++ b/src/plugins/platforms/windows/qtwindowsglobal.h
@@ -241,8 +241,10 @@ inline QtWindows::WindowsEventType windowsEventType(UINT message, WPARAM wParamI
     case WM_GETOBJECT:
         return QtWindows::AccessibleObjectFromWindowRequest;
     case WM_SETFOCUS:
+        qDebug("WM_SETFOCUS");
         return QtWindows::FocusInEvent;
     case WM_KILLFOCUS:
+        qDebug("WM_KILLFOCUS");
         return QtWindows::FocusOutEvent;
     // Among other things, WM_SETTINGCHANGE happens when the taskbar is moved
     // and therefore the "working area" changes.
diff --git a/src/plugins/platforms/windows/qwindowscontext.cpp b/src/plugins/platforms/windows/qwindowscontext.cpp
index 1da39a0516..830300d5fb 100644
--- a/src/plugins/platforms/windows/qwindowscontext.cpp
+++ b/src/plugins/platforms/windows/qwindowscontext.cpp
@@ -957,6 +957,12 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
     } // InputMethodEventFlag
 
     switch (et) {
+    case QtWindows::ActivateApplicationEvent:
+        qDebug("ACTIVATE");
+        break;
+    case QtWindows::DeactivateApplicationEvent:
+        qDebug("DEACTIVATE");
+        break;
     case QtWindows::GestureEvent:
         return sessionManagerInteractionBlocked() || d->m_mouseHandler.translateGestureEvent(platformWindow->window(), hwnd, et, msg, result);
     case QtWindows::InputMethodOpenCandidateWindowEvent:
@@ -1049,6 +1055,7 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
     case QtWindows::InputMethodKeyEvent:
     case QtWindows::InputMethodKeyDownEvent:
     case QtWindows::AppCommandEvent:
+        qDebug("KEYEVENT");
         return sessionManagerInteractionBlocked() ||  d->m_keyMapper.translateKeyEvent(platformWindow->window(), hwnd, msg, result);
     case QtWindows::MenuAboutToShowEvent:
         if (sessionManagerInteractionBlocked())
@@ -1232,6 +1239,7 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
 void QWindowsContext::handleFocusEvent(QtWindows::WindowsEventType et,
                                        QWindowsWindow *platformWindow)
 {
+    qDebug() << __FUNCTION__ << et << platformWindow;
     QWindow *nextActiveWindow = 0;
     if (et == QtWindows::FocusInEvent) {
         QWindow *topWindow = QWindowsWindow::topLevelOf(platformWindow->window());
diff --git a/src/widgets/kernel/qapplication.cpp b/src/widgets/kernel/qapplication.cpp
index ba315d4338..ba469807d3 100644
--- a/src/widgets/kernel/qapplication.cpp
+++ b/src/widgets/kernel/qapplication.cpp
@@ -3105,8 +3105,9 @@ bool QApplication::notify(QObject *receiver, QEvent *e)
             bool isWidget = receiver->isWidgetType();
 #if QT_CONFIG(graphicsview)
             const bool isGraphicsWidget = !isWidget && qobject_cast<QGraphicsWidget *>(receiver);
-#endif
+#endif            
             QKeyEvent* key = static_cast<QKeyEvent*>(e);
+            qDebug() << __FUNCTION__ << e;
             bool def = key->isAccepted();
             QPointer<QObject> pr = receiver;
             while (receiver) {